/*
	Vertris v0.3.2
	Copyright (C) 2006 - 2007, Andrs Rassol
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>

#include "vertris.h"

char Vertris[VERTRIS_W][VERTRIS_H];
Vertromino Vertro;

extern char Max_Name[MAX_HISCORES][NAME_LENGTH];
extern unsigned int Lines, Max_Lines[MAX_HISCORES], Score, Max_Score[MAX_HISCORES], Level;
extern char Fullscreen;

void load_state()
{
	int i, j;
	int x, y;

	FILE *hiscores = fopen("hiscores.dat", "r");

	if (hiscores)
	{
		for (i = 0; i < MAX_HISCORES; i++)
			fscanf(hiscores, "%s %d %d\n", &Max_Name[i], &Max_Score[i], &Max_Lines[i]);

		fclose(hiscores);
	}

	FILE *game_state = fopen("vertris.sav", "r");

	if (!game_state)
		return;

	fscanf(game_state, "%d %d\n", &Score, &Lines);

	fscanf(game_state, "%d %d %d %c", &x, &y, &Vertro.dir, &Vertro.type);
	set_vertro(Vertro.type, Vertro.dir);

	Vertro.x = x;
	Vertro.y = y;

	for (j = VERTRIS_H; j--; )
	{
		fscanf(game_state, "\n");
		for (i = 0; i < VERTRIS_W; i++)
		{
			fscanf(game_state, "%c", &Vertris[i][j]);
			if (Vertris[i][j] == '.')
				Vertris[i][j] = 0;
		}
	}

	fclose(game_state);

	Level = level();
}

void load_prefs()
{
	FILE *preferences = fopen("preferences", "r");

	if (preferences)
	{
		fscanf(preferences, "fullscreen %d\n", &Fullscreen);
		fclose(preferences);
	}
}

void save_state()
{
	int i, j;

	FILE *hiscores = fopen("hiscores.dat", "w");
	for (i = 0; i < MAX_HISCORES; i++)
		fprintf(hiscores, "%s %d %d\n", Max_Name[i], Max_Score[i], Max_Lines[i]);
	fclose(hiscores);

	FILE *game_state = fopen("vertris.sav", "w");

	fprintf(game_state, "%d %d\n", Score, Lines);

	fprintf(game_state, "%d %d %d %c", Vertro.x, Vertro.y, Vertro.dir, Vertro.type);

	for (j = VERTRIS_H; j--; )
	{
		fprintf(game_state, "\n");
		for (i = 0; i < VERTRIS_W; i++)
		{
			if (Vertris[i][j] == 0)
				Vertris[i][j] = '.';
			fprintf(game_state, "%c", Vertris[i][j]);
		}
	}

	fclose(game_state);


	FILE *preferences = fopen("preferences", "w");

	fprintf(preferences, "fullscreen %d\n", Fullscreen);
	fclose(preferences);
}
